# -*- coding: iso-8859-1 -*-
## ----------------------------------------------------------------------
## PyCoinCoin - Module MultiDetector
##   Ce module dfinit le plug-in MultiDetector : interface vers le 
##   Bureau de Recherche des Multis http://renardjb.free.fr/test/multi/
## ----------------------------------------------------------------------

import logging
log = logging.getLogger('pycc')
import sys
sys.path.append('..')

from coinlib.plugin import *
from coinlib.baseclasses import Post
from cointklib.basicwidgets import SplashWindow

import tkSimpleDialog
import xml.dom.minidom

def build_plugins(pycc):
  return { \
    'multidetector': MultiDetector(pycc, "Multi-Detector", "Recherche des multis")
  }

def getText(nodelist, encoding='iso-8859-15'):
  rc = ""
  for node in nodelist:
    if node.nodeType == node.TEXT_NODE:
      rc = rc + node.data
  return toUnicode(rc, encoding)

class MultiDetector(Plugin):
  
  def getMulti(self, pseudo):
    try:
      f = open_url("renardjb.free.fr", "/test/multi/multi.php?multi=%s" % pseudo, self.pycc.options)
      response = f.read()
      f.close()
    except:
      response = ""
      self.error = "Erreur rseau ou du serveur des Chinois du FBI"
      log.error(self.error)
    return response
  
  def disp_res(self, text):
    SplashWindow(self.pycc.root, "Multi Detector", text)
    self.pycc.root.update_idletasks()
  
  def action_menu(self):
    res = tkSimpleDialog.askstring("Multi Detector", "Entrer un login/pseudo:", parent=self.pycc.root)
    if res is not None:
      dummypost = Post('0', login=res)
      self.process(self.pycc.bouchots[self.pycc.get_bouchot()], "PINNI", dummypost)
  
  def process(self, bouchot, context, post=None):
    info = SplashWindow(self.pycc.root, "Multi Detector", "Recherche en cours...")
    self.pycc.root.update_idletasks()
    xmlres = self.getMulti(post.login)
    if not xmlres:
      self.disp_res(self.error)
      return
    try:
      dom = xml.dom.minidom.parseString(xmlres)
    except:
      self.error = "Erreur sur le parsing XML de la rponse"
      self.disp_res(self.error)
      return
    items = dom.getElementsByTagName("multi")
    info.destroy()
    if len(items):
      res = u"Multis de '%s':" % post.login
      for entry in items:
        multis = entry.getElementsByTagName("login")
        res += "\n" + " = ".join([getText(login.childNodes) for login in multis])
      self.disp_res(res)
    else:
      self.disp_res(u"Aucun multi trouv pour '%s'\n(une dlation sera bienvenue si vous possdez\ndes informations  son sujet)" % post.login)
