# -*- coding: iso-8859-1 -*-
## ----------------------------------------------------------------------
## PyCoinCoin - Module traducteur
##   Ce module dfinit le plug-in Traducteur (bot interfac avec babelfish)
## ----------------------------------------------------------------------

import logging
log = logging.getLogger('pycc')
import sys
sys.path.append('..')
from coinlib.plugin import *
from coinlib.persistants import Identity

import re, urllib

def build_plugins(pycc):
  return { \
    'traducteur': Traducteur(pycc, "Traducteur", "Un bot-interprete")
  }

def zapTags(msg):
  """ Renvoie la chane 'msg' purge des tags xml
  """
  start = msg.find("<")
  end = 0
  res = ""
  while start >= end:
    res += msg[end:start]
    end = msg.find(">", start) + 1
    if end < start: break
    start = msg.find("<", end)
  res += " " + msg[end:]
  return res

class Traducteur(Plugin):
  
  def init(self):
    self.regexp = re.compile(".*[Tt]raduc[<]\s+([a-z][a-z]*_[a-z][a-z]*)\s+(.*)$")
  
  def process(self, bouchot, context, post=None):
    text = post.message
    re_parm = self.regexp.match(text)
    if not re_parm:
      self.error = "Traducteur: invocation incorrecte (manque les langues ?)"
      print "### Error Traducteur", self.error
      return
    args = re_parm.groups()
    if args[0] == "fr_sms":
      try:
        taux = int(args[1].split()[0])
        texte = args[1][len("%d"%taux)+1:]
      except:
        taux = 100
        texte = args[1]
        #self.error = "SMS-traduc mal invoqu (taux incorrect)"
        #print "### Error", self.error
        #return
      try:
        query = urllib.urlencode({'proba': taux, 'text': texte})
        #print "### Query", query
        f = open_url("glossa.fltr.ucl.ac.be", "/programs/fr2sms.pl", self.pycc.options, data=query, headers={'Accept-Charset': "ISO-8859-1,utf-8;q=0.7,*;q=0.7"}) #, 'Referer': "http://babelfish.altavista.com/tr"})
        page = f.read()
        f.close()
        #print "#################################"
        #print page
        #print "#################################"
      except:
        self.error = "Erreur rseau ou du serveur"
        print "### Error Traducteur", self.error
        return
      start = page.find("URL=http://") + 11
      end = page.find('"', start)
      res = page[start:end]
      delim = res.find('/')
      host = res[:delim]
      url = res[delim:]
      print "###", host, url
      try:
        f = open_url(host, url, self.pycc.options, data=query, headers={'Accept-Charset': "ISO-8859-1,utf-8;q=0.7,*;q=0.7"}) #, 'Referer': "http://babelfish.altavista.com/tr"})
        page = f.read()
        f.close()
        #print "#################################"
        #print page
        #print "#################################"
      except:
        self.error = "Erreur rseau ou du serveur"
        print "### Error Traducteur", self.error
        return
      start = page.find('<div align="left" style="overflow:scroll;height:245px;width:380px;">') + 68
      end = page.find("</div>", start)
      res = page[start:end].strip()
      #print "#### res = ", res
      topost = zapTags(res)
      #print "#### topost = ", topost
    elif args[0] == 'fr_morse':
      topost = bouchot.pycc.plugins['morseencode'].text_transform(args[1])
    elif args[0] == 'morse_fr':
      topost = bouchot.pycc.plugins['morsedecode'].text_transform(args[1])
    else:
      if args[0] not in [ "zh_en", "zt_en", "en_zh", "en_zt", "en_nl", "en_fr", 
                         "en_de", "en_el", "en_it", "en_ja", "en_ko", "en_pt",
                         "en_ru", "en_es", "nl_en", "nl_fr", "fr_en", "fr_de",
                         "fr_el", "fr_it", "fr_pt", "fr_nl", "fr_es", "de_en", 
                         "de_fr", "el_en", "el_fr", "it_en", "it_fr", "ja_en",
                         "ko_en", "pt_en", "pt_fr", "ru_en", "es_en", "es_fr" ]: return
      text = args[1]
      try:
        text = text.encode('utf-8')
      except:
        print "### mouais..."
      try:
        query = urllib.urlencode({'lp': args[0], 'trtext': text, 'doit': "done", 'intl': "1", 'tt': "urltext"})
        print "### Query", query
        f = open_url("babelfish.altavista.com", "/tr", self.pycc.options, data=query, headers={'Accept-Charset': "ISO-8859-1,utf-8;q=0.7,*;q=0.7", 'Referer': "http://babelfish.altavista.com/tr"})
        page = f.read()
        f.close()
        #print "#################################"
        #print page
        #print "#################################"
      except:
        self.error = "Erreur rseau ou du serveur"
        print "### Error Traducteur", self.error
        return
      try:
        res = unicode(page, "utf-8")
      except:
        res = page
        #print "### Encoding foirage"
      start = res.find(ur"<td bgcolor=white class=s><div style=padding:10px;>") + 51
      end = res.find(ur"</div>", start)
      topost = res[start:end].strip()
    try:
      # print "coucou"
      bouchot.trib.poster("%s %s" % (post.dispTimeRef(), topost), 1, Identity(login="Traducteur", ua="Traducteur"))
    except:
      self.error = "Impossible de poster dans le bouchot %s" % bouchot.name
      print "### Error Traducteur", self.error
